// loud.cpp: implementation of the Cloud class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "rangeimage.h"
#include "Cloud.h"
#include "Data.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Cloud::Cloud()
{
	data = NULL;
    size = 0;
}

Cloud::~Cloud()
{
  if (data != NULL)
	  delete [] data;
}

void Cloud::allocate(int n)
{
   size =n;
   data = new point[n];
}

void Cloud::setSizeInfo(int row, int col)
{
  this->row = row;
  this->col = col;
}

void Cloud::cloud_to_image(CImage *image)
{
  image->setImageInfo(row, col, 0);
  image->allocate(row, col);

  for (int j=0; j< row; j++){
	  for (int i=0; i<col; i++)
	    image->setPixelVal(j, i, data[j*col+i].height);
  }

}

void Cloud::cloud_to_data(Data *dt)
{
  dt->step = -this->data[10].x + this->data[11].x;
	
  for (int i=0; i<col; i++)
    for (int j=0; j< row; j++)
     {
		float val = this->data[j*col+i].height;
        dt->setValue(j, i, val);
	  }
}
