// Data.cpp: implementation of the Data class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Data.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////


Data::Data():row(0), col(0), step(0), Value(NULL)
{
  Type = NULL;
  flag =NULL;
  Points = NULL;
  Faces = NULL;
}

Data::Data(int row_in, int col_in)
{
	this->row = row_in;
	this->col = col_in;
	Value = new float[row*col];

	Type = NULL;
	flag = NULL;
	Points =NULL;
	Faces = NULL;
}

Data::~Data()
{
	if (Value != NULL)
	  delete [] Value;
	
	if (Type != NULL)
	  delete [] Type;

	if (Points != NULL)
	  delete [] Points;

	if (Faces != NULL)
		delete [] Faces;

  row =0;
  col =0;
}

void Data::setValue(int j, int i, float val)
{
  Value[j*col+i] = val;  
}

float Data::getValue(int j, int i)
{
  return(Value[j*col+i]);
}

void Data::erase()
{
	if (Value !=NULL)
		delete [] Value;
	Value = NULL;

	if (Type != NULL)
      delete[] Type;
	Type = NULL;
	

 row = 0;    
 col = 0; 
}

void Data::allocate(int row_in, int col_in)
{
	this->row = row_in;
	this->col = col_in;
	Value = new float[row*col];
}

void Data::setType(int y, int x, enum type t)
{
  Type[y*col+x]= t;
}

type Data::getType(int y, int x)
{
  return( this->Type[y*this->col+x]);
}

void Data::allocateType()
{
	if (Type != NULL)
		delete [] Type;

	Type = new type[row*col];
	
	for(int i=0; i<row*col; i++)
          Type[i] = REG;
	  
}


void Data::triangulate()
{
	Points = new float[row*col][3];
	Faces = new int[2*(row-1)*(col-1)][3];

	float c_x = 0.5*step*col;
    float c_y = 0.5*step*row;

	for (int j=0; j<row; j++){	  
	   for (int i=0; i<col; i++){
          Points[j*col+i][0] = i*step-c_x;
          Points[j*col+i][1] = j*step-c_y;
          Points[j*col+i][2] = Value[j*col+i];
	   }
	 }

	int count =0;
	for (j=0; j<row-1; j++){	  
	   for (int i=0; i<col-1; i++){
         Faces[count][0] = j*col+i;
         Faces[count][1] = (j+1)*col+i;
         Faces[count][2] = (j+1)*col+(i+1);
         count++;

         Faces[count][0] = j*col+i;
         Faces[count][1] = (j+1)*col+(i+1);
         Faces[count][2] = j*col+(i+1);
		 count ++;
	   }
	  }

}


