// FileManager.cpp: implementation of the CFileManager class.
//
////////////////////////////////////////////////////////////////////// 
#include "stdafx.h"
#include "RangeImage.h"
#include "FileManager.h"

#include <iostream.h>
#include <fstream.h>
#include <stdlib.h>

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CFileManager::CFileManager()
{

}

CFileManager::~CFileManager()
{

}

void CFileManager::readPGM(CString fname, CImage *image)
{
  char header [100], *ptr;
  int rows, cols, max;
  int type;

  ifstream ifp;
  ifp.open(fname, ios::in);
  if (!ifp) {
   AfxMessageBox("Can't read image: " + fname );
   return;
  }

  ifp.getline(header,100,'\n');
  if ( (header[0] == 80) &&  /* 'P' */
       (header[1]== 53) ) {  /* '5' */
       type = 5;
  }
  else if ( (header[0] == 80) &&    /* 'P' */
       (header[1] == 50) ) {        /* '2' */
       type = 2;
  } 
  else {
    AfxMessageBox(fname + " is not PGM file");
    return;
  }

  ifp.getline(header,100,'\n');
  while(header[0]=='#')
    ifp.getline(header,100,'\n');

  cols = strtol(header,&ptr,0);
  rows = atoi(ptr);

  ifp.getline(header,100,'\n');
  max = strtol(header,&ptr,0);

  int factor = 256/(max+1);
     
  image->setImageInfo(rows, cols, max);
  image->allocate(rows, cols);
   
  float val;

  if (type == 5){
     unsigned char *charImage;
     charImage = (unsigned char *) new unsigned char [rows*cols];
     ifp.read( reinterpret_cast<char *>(charImage), (rows*cols)*sizeof(unsigned char));

     ifp.close();

	 for(int i=0; i<rows; i++)
	    for(int j=0; j<cols; j++){ 
         val = ((float)charImage[i*cols+j])*factor;
         image->setPixelVal(i, j, val);     
	   }
	 
  
    delete [] charImage;

  }
  else if (type == 2){     
   for(int i=0; i<rows; i++)
    for(int j=0; j<cols; j++) {
       int data;
       ifp >> data;
       val = (float) data*factor;
       image->setPixelVal(i, j, val);     
	 }    
    ifp.close();
  }
	  
}

void CFileManager::readPGM_header(CString fname, int &r, int &c, int &l, int &type)
{
  char header [100], *ptr;
 
  ifstream ifp;
  ifp.open(fname, ios::in);

  if (!ifp) {
   AfxMessageBox("Can't read image: " + fname );
   return;
  }

  ifp.getline(header,100,'\n');
  if ( (header[0] == 80) &&  /* 'P' */
       (header[1]== 53) ) {  /* '5' */
       type = 5;
  }
  else if ( (header[0] == 80) &&    /* 'P' */
       (header[1] == 50) ) {        /* '2' */
       type = 2;
  } 
  else {
    AfxMessageBox(fname + " is not PGM file");
    return;
  }

  ifp.getline(header,100,'\n');
  while(header[0]=='#')
    ifp.getline(header,100,'\n');

  c = strtol(header,&ptr,0);
  r = atoi(ptr);

  ifp.getline(header,100,'\n');

  l = strtol(header,&ptr,0);

  ifp.close();
}

void CFileManager::readDAT(CString file_name, CImage *image)
{
	FILE* file = fopen(file_name, "r");

	int cols;
	fscanf(file, "%d", &cols);
	int rows;
	fscanf(file, "%d", &rows);
	int max;
	fscanf(file, "%d", &max);

	image->setImageInfo(rows, cols, max);
    image->allocate(rows, cols);

	for(int i=0; i<rows; i++)
		for(int j=0; j<cols; j++){
			float data;
			fscanf(file, "%f", &data);
			image->setPixelVal(i,j, data*255.0f/(float)max);
		}

	fclose(file);
}

void CFileManager::readHeight(CString file_name, Cloud *cl)
{
	FILE* file = fopen(file_name, "r");
	if (file == NULL){

	}
      
	/* Set pointer to beginning of file: */
    fseek(file, 0L, SEEK_SET );

	int num_points;
	fscanf(file, "%d", &num_points);
    cl->allocate(num_points);

	int col, row;
	fscanf(file, "%d", &col);
	fscanf(file, "%d", &row);
	cl->setSizeInfo(row, col);

	float tm;
// data  goes along x_axe first
//
	for(int i=0; i<num_points; i++){
			fscanf(file, "%f", &tm);
			cl->data[i].x = tm;
			fscanf(file, "%f", &tm);
			cl->data[i].y= tm;
			fscanf(file, "%f", &tm);
			cl->data[i].height = tm;
		}

	fclose(file);
}

void CFileManager::reatTXT(CString file_name, Data *dt)
{
	FILE* file = fopen(file_name, "r");
	if (file == NULL){

	}
   
	int col, row, i;
	char temp;

//	fscanf(file,"%d %*[^\n]",row); /* read nrows */
//   fscanf(file,"%d %*[^\n]",col); /* read ncols */
//    fscanf(file,"%1s %*[^\n]",&d);   /* skip comment line */


	fscanf(file, "%d %s", &row, &temp);
	fscanf(file, "%d %s", &col, &temp);
    while ( fgetc(file) != ':')
		;

	int num_points = col*row;

	int *flag = new int[num_points];
    float *Z= new float[num_points];

	int t;
	for (int j=0; j<num_points; j++){
          fscanf(file, "%d ", &t);
          flag[j] = t;
		}
	
    float tm;
	for (i=0; i<num_points; i++)
		fscanf(file, "%f", &tm); 

	for (i=0; i<num_points; i++)
		fscanf(file, "%f", &tm);

    int k=0;
	while (flag[k] == 0){
	   fscanf(file, "%f", &tm);
       Z[k] = tm;
	   k++;
	   }
    fscanf(file, "%f", &tm);
    Z[k] = tm;
	float min_Z = tm;
	float max_Z = tm;
	for ( j=k+1; j<num_points; j++){
          fscanf(file, "%f", &tm);
		  Z[j] = tm;
          if (tm<min_Z && flag[j] == 1)
			  min_Z =tm;
		  if (tm>max_Z &&flag[j] == 1)
			  max_Z = tm;		  
		}

	dt->allocate(row, col);
	dt->flag = flag;
	dt->step =1;
	if (min_Z >0) min_Z=0;
	for ( j=0; j<row; j++)
		for (int i=0; i<col; i++){
			if (flag[j*col+i] == 1)
               dt->setValue(j, i, -min_Z + Z[j*col+i]);
			else 
              dt->setValue(j, i, 0);
		}

	fclose(file);
	delete [] Z;
}
