// FileManager.cpp: implementation of the CFileManager class.
//
////////////////////////////////////////////////////////////////////// 
#include "stdafx.h"
#include "RangeImage.h"
#include "FileManager.h"

#include <iostream.h>
#include <fstream.h>
#include <stdlib.h>

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CFileManager::CFileManager()
{

}

CFileManager::~CFileManager()
{

}

void CFileManager::readPGM(CString fname, CImage *image)
{
  char header [100], *ptr;
  int rows, cols, max;

  int type;
  ifstream ifp;

  ifp.open(fname, ios::in);

  if (!ifp) {
   AfxMessageBox("Can't read image: " + fname );
   return;
  }

  ifp.getline(header,100,'\n');
  if ( (header[0] == 80) &&  /* 'P' */
       (header[1]== 53) ) {  /* '5' */
       type = 5;
  }
  else if ( (header[0] == 80) &&    /* 'P' */
       (header[1] == 50) ) {        /* '2' */
       type = 2;
  } 
  else {
    AfxMessageBox(fname + " is not PGM file");
    return;
  }

  ifp.getline(header,100,'\n');
  while(header[0]=='#')
    ifp.getline(header,100,'\n');

  cols = strtol(header,&ptr,0);

  rows = atoi(ptr);

  ifp.getline(header,100,'\n');

  max = strtol(header,&ptr,0);

  if (type == 5){
     unsigned char *charImage;
     charImage = (unsigned char *) new unsigned char [rows*cols];
     ifp.read( reinterpret_cast<char *>(charImage), (rows*cols)*sizeof(unsigned char));

     if (ifp.fail()) {
       AfxMessageBox("Image " + fname + " has wrong size" );
       return;
	 }
     ifp.close();

     image->allocate(rows, cols);

   //
   // Convert the unsigned characters to integers
   //
   float val;
   for(int i=0; i<rows; i++)
     for(int j=0; j<cols; j++) {
       val = 255.0f*(float)charImage[j*cols+i]/(float)max;
       image->setPixelVal(i, j, val);     
	 }
  
    delete [] charImage;
	return;
  }
  else if (type == 2){
   image->setImageInfo(rows, cols, max);
   image->allocate(rows, cols);

   for(int i=0; i<rows; i++)
     for(int j=0; j<cols; j++) {
       int data;
       ifp >> data;
       float val = data*255.0f/(float)max;
       image->setPixelVal(i, j, val);     
	 }
      
	 ifp.close();
  }
}

void CFileManager::readPGM_header(CString fname, int &r, int &c, int &l, int &type)
{
  char header [100], *ptr;
 
  ifstream ifp;
  ifp.open(fname, ios::in);

  if (!ifp) {
   AfxMessageBox("Can't read image: " + fname );
   return;
  }

  ifp.getline(header,100,'\n');
  if ( (header[0] == 80) &&  /* 'P' */
       (header[1]== 53) ) {  /* '5' */
       type = 5;
  }
  else if ( (header[0] == 80) &&    /* 'P' */
       (header[1] == 50) ) {        /* '2' */
       type = 2;
  } 
  else {
    AfxMessageBox(fname + " is not PGM file");
    return;
  }

  ifp.getline(header,100,'\n');
  while(header[0]=='#')
    ifp.getline(header,100,'\n');

  c = strtol(header,&ptr,0);
  r = atoi(ptr);

  ifp.getline(header,100,'\n');

  l = strtol(header,&ptr,0);

  ifp.close();
}

void CFileManager::readDAT(CString file_name, CImage *image)
{
	FILE* file = fopen(file_name, "r");

	int cols;
	fscanf(file, "%d", &cols);
	int rows;
	fscanf(file, "%d", &rows);
	int max;
	fscanf(file, "%d", &max);

	image->setImageInfo(rows, cols, max);
    image->allocate(rows, cols);

	for(int i=0; i<rows; i++)
		for(int j=0; j<cols; j++){
			float data;
			fscanf(file, "%f", &data);
			image->setPixelVal(i,j, data*255.0f/(float)max);
		}

	fclose(file);
}
