// Geometry.cpp: implementation of the Geometry class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "RangeImage.h"
#include "Geometry.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Geometry::Geometry()
{

}

Geometry::~Geometry()
{

}

BOOL Geometry::isZero(float s)
{
  if (fabs(s) < 1e-6)  return(1);
  else return(0);
}




void Geometry::CENTEROID(double c[], float p1[], float p2[], float p3[])
{
	c[0] = (p1[0] + p2[0] + p3[0])/3.0;
	c[1] = (p1[1] + p2[1] + p3[1])/3.0;
	c[2] = (p1[2] + p2[2] + p3[2])/3.0;
}

void Geometry::NORMAL(float n[], float p0[], float p1[], float p2[])
{
	float v1[3], v2[3];
	float length;
	Geometry::VEC(v1, p0, p1);
        Geometry::VEC(v2, p0, p2);
		Geometry::CROSS(n, v1, v2);
		length = (float)Geometry::LENGTH(n);
		if(length != 0){
			n[0] /= length;
			n[1] /= length;
			n[2] /= length;
		}
		else
			n[0] = n[1] = n[2] = 0.0f;
}

//to get minimal dihedral angle between 2 triangles
//triangles are oriented 
//
double Geometry::ANGLE(float vec1[3], float vec2[3])
{
    double angle;

    double dot = Geometry::DOT(vec1, vec2);

	if(dot > 1.0)
		dot = 1.0;
	else if(dot < -1.0)
		dot = -1.0;

	angle = acos(dot) ;
 
	return angle;
}
