// RangeImageDoc.cpp : implementation of the CRangeImageDoc class
//

#include "stdafx.h"
#include "RangeImage.h"
#include "FileManager.h"
#include "RangeImageDoc.h"
#include "RangeImageView.h"
#include "Dia_ridge.h"
#include "Featurer.h" 
#include "MeshData.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CRangeImageDoc

IMPLEMENT_DYNCREATE(CRangeImageDoc, CDocument)

BEGIN_MESSAGE_MAP(CRangeImageDoc, CDocument)
	//{{AFX_MSG_MAP(CRangeImageDoc)
	ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
	ON_COMMAND(ID_SHOWFEATURES, OnShowFeatures)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CRangeImageDoc construction/destruction

CRangeImageDoc::CRangeImageDoc(): data(NULL), m_features(FALSE)
{
	// TODO: add one-time construction code here   
	
}

CRangeImageDoc::~CRangeImageDoc()
{

}

void CRangeImageDoc::DeleteContents()
{
	if (data != NULL)
		delete data; 

	data = NULL;
	m_features = FALSE;
}

BOOL CRangeImageDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)

	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CRangeImageDoc serialization

void CRangeImageDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
}

/////////////////////////////////////////////////////////////////////////////
// CRangeImageDoc diagnostics

#ifdef _DEBUG
void CRangeImageDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CRangeImageDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CRangeImageDoc commands

void CRangeImageDoc::OnFileOpen() 
{
	// TODO: Add your command handler code here
    char file_ex[] = "All Files (*.*)|*.*|PGM files(*.PGM)|*.PGM|Float array files(*.DAT)|*.DAT|Height data(*.hgt)||";
	CFileDialog* dia = new CFileDialog(TRUE, NULL, NULL, 
	OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, file_ex, NULL);
	
	if(dia->DoModal() == IDOK){
      BeginWaitCursor();
        CString file_name = dia->GetPathName();
        CString file_ext = dia->GetFileExt();
       
		mode = mesh;
		int col, row, tmp;
		m_features = FALSE;

        CFileManager man;
		if (file_ext == "pgm"){
           CImage* image = new CImage();
		   man.readPGM(file_name, image);
		   image->getImageInfo(row, col, tmp);
           this->data = new Data(row, col);
		   image->image_to_data(data);
		   delete image;
		}
		else if(file_ext == "dat"){
            CImage* image = new CImage();
			man.readDAT(file_name, image);
            image->getImageInfo(row, col, tmp);
            this->data = new Data(row, col);
            image->image_to_data(data);
            delete image;
		}
		else if (file_ext == "hgt"){
			Cloud* cl = new Cloud();
            man.readHeight(file_name, cl);
			this->data = new Data(cl->row, cl->col);
			cl->cloud_to_data(this->data);
			delete cl;
		}
        else if (file_ext == "txt"){
			data = new Data();
            man.reatTXT(file_name, this->data);
		}
	EndWaitCursor();
	
   CMDIFrameWnd *pFrame = 
             (CMDIFrameWnd*)AfxGetApp()->m_pMainWnd;

   // Get the active MDI child window.
   CMDIChildWnd *pChild = 
             (CMDIChildWnd *) pFrame->GetActiveFrame();

    CString s1 = dia->GetFileName();
    pChild->SetWindowText(s1);
    
	changeView();

	}
	delete dia;
	
}

void CRangeImageDoc::changeView()
{
	POSITION pos = GetFirstViewPosition();
	CRangeImageView* pView = (CRangeImageView*)GetNextView(pos);
	pView->changeView();
}

void CRangeImageDoc::drawImage()
{
	if(image == NULL)
		return;
	POSITION pos = GetFirstViewPosition();
	CRangeImageView* pView = (CRangeImageView*)GetNextView(pos);

	switch(mode){
	case shaded:
		pView->drawShaded(data);
		break;
	case points:
     pView->drawPoints(data);
	 break;
	case mesh:
     pView->drawMesh(data);
	 break;
	}
	
	if (m_features)
      pView->drawFeatures(data);
}

void CRangeImageDoc::OnShowFeatures() 
{
	// TODO: Add your command handler code here

	Dia_ridge* dia = new Dia_ridge();

	if(dia->DoModal() == IDOK){
        int rows = data->row;
        int cols = data->col; 

		if (data->Type != NULL){
			delete [] data->Type;
            data->Type = NULL;
		}

        data->allocateType();
		
		Featurer *ft = new Featurer();
		ft->setData(data);
		if (dia->m_statistic == TRUE){
		   ft->m_hyster_max = ft->m_hyster_min = 0;
		   ft->m_curv_thresh_max = ft->m_curv_thresh_min = 0;
		   ft->m_statistic = TRUE;
		   ft->percent_hi = dia->m_percent_hi;
		   ft->percent_low = dia->m_percent_low;

		}
		else{
           ft->m_hyster_max = dia->m_hyster_max;
		   ft->m_hyster_min = dia->m_hyster_min;
		   ft->m_curv_thresh_max = dia->m_curv_thresh_max; 
		   ft->m_curv_thresh_min = dia->m_curv_thresh_min;
		}

		if (dia->m_exp_autom == TRUE){
            ft->m_expo_aut =TRUE;
			ft->m_expo_percent = dia->m_exp_perc;
		}
	    
        ft->m_thinning = dia->m_thinning;

        BeginWaitCursor(); 
        ft->StMarc(dia->m_iter, dia->m_param);
		delete ft;
		m_features = TRUE;
        EndWaitCursor();
        changeView();
	}

	delete dia;
    
}
