// RangeImageView.h : interface of the CRangeImageView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_RANGEIMAGEVIEW_H__14FBEB60_C55D_4987_8C70_821C7CC498EF__INCLUDED_)
#define AFX_RANGEIMAGEVIEW_H__14FBEB60_C55D_4987_8C70_821C7CC498EF__INCLUDED_

#include "RangeImageDoc.h"	// Added by ClassView
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <gl\gl.h>
#include <gl\glu.h>
#include <math.h>
#include "Data.h"

class CRangeImageView : public CView
{
protected: // create from serialization only
	CRangeImageView();
	DECLARE_DYNCREATE(CRangeImageView)

// Attributes
public:
	CRangeImageDoc* GetDocument();
    void changeView();
    void drawShaded(Data *dt);

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CRangeImageView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	//}}AFX_VIRTUAL

// Implementation
public:
	BOOL m_back_plane_on;
	void drawMesh(Data* dt);
	void drawPoints(Data* data);
	void drawHeigh();
	void drawFeatures(Data *dt);
	virtual ~CRangeImageView();
	int*falg;
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	HGLRC m_hRC;
	GLdouble eye[3], center[3];
	GLfloat Rx,Ry,Rz;
	int px, py;
	float vx[3], vy[3];
	BOOL isLPressed, isRPressed;
	bool isPerspective;
	float view_angle;
	float shift_x, shift_y, shift_z;

// Generated message map functions
protected:
	void initGL();
	//{{AFX_MSG(CRangeImageView)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnDestroy();
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	
};

#ifndef _DEBUG  // debug version in RangeImageView.cpp
inline CRangeImageDoc* CRangeImageView::GetDocument()
   { return (CRangeImageDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_RANGEIMAGEVIEW_H__14FBEB60_C55D_4987_8C70_821C7CC498EF__INCLUDED_)
